warning off all

% sets the path
cd PUT YOUR PATH HERE

% If you want a diary, uncomment what follows and give it a name
%delete('my_log.out');
%diary('my_log.out');
format long;




disp('%%%%%%%%');
disp('est_a_1');
disp('%%%%%%%%');

% input data
clear
All1 = load( 'data/est_high_mem_aer_1' );
include = All1.include;
x = All1.x;
gamma = All1.gamma;
p = All1.p;
x_M = All1.x_M;
vc_bs = All1.vc_bs;

% play with results
x = [gamma; p(1:end-1)];

% standard errors
std = sqrt(diag(vc_bs));

% display basic results
foo = [-999, include]';
bar = [x; p(end)];
baz = [sqrt(diag(vc_bs)); -999];
[foo, bar, baz]
beta = 1 / ( 1 + exp( -1 / x(1) ) )



disp(' ');
disp('Tests equality to 0 using the waldtest');
disp('------------------------');

[ws wp] = waldtest_gf(x, [1], 0, vc_bs);
disp(' ');
disp(sprintf('p-value of gamma = 0: %1.3f',1-wp));
for i = 2:length(include)
    [ws wp] = waldtest_gf(x, [i], 0, vc_bs);
    if x(i) > eps
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: %1.3f',include(i-1),1-wp));
    else
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(i-1)));
    end
end
if p(end) > eps
    [ws wp] = waldtest_gf(x, [0,ones(1,length(include)-1)], 1, vc_bs);
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: %1.3f',include(end),1-wp));
else
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(end)));
end




disp('%%%%%%%%');
disp('est_a_2');
disp('%%%%%%%%');

% input data
clear
All2 = load( 'data/est_high_mem_aer_2' );
include = All2.include;
x = All2.x;
gamma = All2.gamma;
p = All2.p;
x_M = All2.x_M;
vc_bs = All2.vc_bs;

% play with results
x = [gamma; p(1:end-1)];

% standard errors
std = sqrt(diag(vc_bs));

% display basic results
foo = [-999, include]';
bar = [x; p(end)];
baz = [sqrt(diag(vc_bs)); -999];
[foo, bar, baz]
beta = 1 / ( 1 + exp( -1 / x(1) ) )


disp(' ');
disp('Tests equality to 0 using the waldtest');
disp('------------------------');

[ws wp] = waldtest_gf(x, [1], 0, vc_bs);
disp(' ');
disp(sprintf('p-value of gamma = 0: %1.3f',1-wp));
for i = 2:length(include)
    [ws wp] = waldtest_gf(x, [i], 0, vc_bs);
    if x(i) > eps
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: %1.3f',include(i-1),1-wp));
    else
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(i-1)));
    end
end
if p(end) > eps
    [ws wp] = waldtest_gf(x, [0,ones(1,length(include)-1)], 1, vc_bs);
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: %1.3f',include(end),1-wp));
else
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(end)));
end





disp('%%%%%%%%');
disp('est_a_3');
disp('%%%%%%%%');

% input data
clear
All3 = load( 'data/est_high_mem_aer_3' );
include = All3.include;
x = All3.x;
gamma = All3.gamma;
p = All3.p;
x_M = All3.x_M;
vc_bs = All3.vc_bs;

% play with results
x = [gamma; p(1:end-1)];

% standard errors
std = sqrt(diag(vc_bs));

% display basic results
foo = [-999, include]';
bar = [x; p(end)];
baz = [sqrt(diag(vc_bs)); -999];
[foo, bar, baz]
beta = 1 / ( 1 + exp( -1 / x(1) ) )



disp(' ');
disp('Tests equality to 0 using the waldtest');
disp('------------------------');

[ws wp] = waldtest_gf(x, [1], 0, vc_bs);
disp(' ');
disp(sprintf('p-value of gamma = 0: %1.3f',1-wp));
for i = 2:length(include)
    [ws wp] = waldtest_gf(x, [i], 0, vc_bs);
    if x(i) > eps
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: %1.3f',include(i-1),1-wp));
    else
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(i-1)));
    end
end
if p(end) > eps
    [ws wp] = waldtest_gf(x, [0,ones(1,length(include)-1)], 1, vc_bs);
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: %1.3f',include(end),1-wp));
else
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(end)));
end





disp('%%%%%%%%');
disp('est_a_4');
disp('%%%%%%%%');

% input data
clear
All4 = load( 'data/est_high_mem_aer_4' );
include = All4.include;
x = All4.x;
gamma = All4.gamma;
p = All4.p;
x_M = All4.x_M;
vc_bs = All4.vc_bs;

% play with results
x = [gamma; p(1:end-1)];

% standard errors
std = sqrt(diag(vc_bs));

% display basic results
foo = [-999, include]';
bar = [x; p(end)];
baz = [sqrt(diag(vc_bs)); -999];
[foo, bar, baz]
beta = 1 / ( 1 + exp( -1 / x(1) ) )



disp(' ');
disp('Tests equality to 0 using the waldtest');
disp('------------------------');

[ws wp] = waldtest_gf(x, [1], 0, vc_bs);
disp(' ');
disp(sprintf('p-value of gamma = 0: %1.3f',1-wp));
for i = 2:length(include)
    [ws wp] = waldtest_gf(x, [i], 0, vc_bs);
    if x(i) > eps
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: %1.3f',include(i-1),1-wp));
    else
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(i-1)));
    end
end
if p(end) > eps
    [ws wp] = waldtest_gf(x, [0,ones(1,length(include)-1)], 1, vc_bs);
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: %1.3f',include(end),1-wp));
else
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(end)));
end





disp('%%%%%%%%');
disp('est_a_5');
disp('%%%%%%%%');

% input data
clear
All5 = load( 'data/est_high_mem_aer_5' );
include = All5.include;
x = All5.x;
gamma = All5.gamma;
p = All5.p;
x_M = All5.x_M;
vc_bs = All5.vc_bs;

% play with results
x = [gamma; p(1:end-1)];

% standard errors
std = sqrt(diag(vc_bs));

% display basic results
foo = [-999, include]';
bar = [x; p(end)];
baz = [sqrt(diag(vc_bs)); -999];
[foo, bar, baz]
beta = 1 / ( 1 + exp( -1 / x(1) ) )


disp(' ');
disp('Tests equality to 0 using the waldtest');
disp('------------------------');

[ws wp] = waldtest_gf(x, [1], 0, vc_bs);
disp(' ');
disp(sprintf('p-value of gamma = 0: %1.3f',1-wp));
for i = 2:length(include)
    [ws wp] = waldtest_gf(x, [i], 0, vc_bs);
    if x(i) > eps
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: %1.3f',include(i-1),1-wp));
    else
       disp(' ');
       disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(i-1)));
    end
end
if p(end) > eps
    [ws wp] = waldtest_gf(x, [0,ones(1,length(include)-1)], 1, vc_bs);
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: %1.3f',include(end),1-wp));
else
    disp(' ');
    disp(sprintf('p-value of phi %d = 0: Cannot reject H0',include(end)));
end


disp('------------------------');
disp('------------------------');
disp('------------------------');

