tic

pctRunOnAll warning off all

% sets the path
cd PUT YOUR PATH HERE

% If you want a diary, uncomment what follows and give it a name
%delete('my_log.out');
%diary('my_log.out');
format long;

% input data
clear


%%%%%%%%%%%% IMPUTING PARAMETERS %%%%%%%%%%%%%%%

% Set seed
rand('state', 123456789);

% Set parameters that stay fixed over the different cases (different phi
% and beta)
%
no_session = 5;     % Number of session per treatment
no_subject = 14;    % Number of subject per session
no_match = 10;  % Number of matches
discount = 0.75;  % discount factor

% Number of simulated experiments
no_simul = 1000;

%
% Set parameters for b/c = 2
%
beta = 0.97;    % beta is the probability that the choice coincides with
                % the one prescribed by the strategy.

% class 1
phi_ad = 0.13;     % fraction of AD - strg_choices = 1
phi_ac = 0.18;         % fraction of AC - strg_choices = 2
phi_grim = 0.57;       % fraction of Grim - strg_choices = 3
phi_tft = 0.11;      % fraction of TFT - strg_choices = 4
phi_stft = 0.01;      % fraction of STFT - strg_choices = 5
phi_wsls = 0;
phi_t2 = 0;
% class 2
% class 3
% class 4
phi_tf2t = 0;
phi_tf3t = 0;
phi_2tft = 0;
phi_2tf2t = 0;
phi_grim2 = 0;
phi_grim3 = 0;

phi = [phi_ad; phi_ac; phi_grim; phi_tft; phi_stft; phi_wsls; phi_t2;
       phi_tf2t; phi_tf3t; phi_2tft; phi_2tf2t; phi_grim2; phi_grim3];

%%%%%%%%%%%% LOOPING OVER SIMULATED DATA SETS %%%%%%%%%%%%%%%

% initializing variables
x_M = zeros( no_simul , 6 );

disp('Start Loop 1');
parfor i = 1:no_simul
    [ x ] = sim_power_revision5( no_session, no_subject, no_match, discount, phi, beta );
    x_M(i,:) = x';
end

output_5 = [x_M];

clearvars -EXCEPT output_5 no_session no_subject no_match discount no_simul








% Put the key data together
output = [output_5];



toc

save('data/raw/sim_power_revision5_4b', 'output_5', '-double', '-tabs')
save('data/raw/sim_power_revision5_4b.txt', 'output', '-ascii', '-double', '-tabs')

diary off


