function [x_M, vc_bs, freq_e_bs] = bs_df_strat_plus(match, id, strg_M, K, start, session, reps, strg_e, round)





unique_session = unique(session);                  % vector with session indicator once for every session, no_session x 1
no_session = length(unique_session);               % number of sessions                         

for i = 1:no_session
    no_subjects(i,1) = max(id(session == unique_session(i))) - min(id(session == unique_session(i))) + 1;       % vector with number of subjects in each session, no_session x 1
    foo_match(i,1) = max(match(session == unique_session(i))) - min(match(session == unique_session(i))) + 1;   % vector with number of matches in each session, no_session x 1
end
order_session = tiedrank(no_subjects+(unique_session/100000));      % rank of each session in terms of number of subjects, no_session x 1
for i = 1:no_session
    session_foo(session == unique_session(i)) = order_session(i);    % same as session, but ordered according to the number of subjects, same dimensions as session
end

[value, order] = sort(no_subjects+(unique_session/100000));   % order gives the position of elements of no_subjects if they are sorted, no_session x 1
n_bs = no_subjects(order);       % number of subjects in each session sorted by size, no_session x 1 
no_match = foo_match(order);     % number of matches in each session sorted by size, no_session x 1

% generate new vars
s_val = [1:no_session]';
foo = ones(size(match));





% start loop to compute estimates
x_M = -9999 * ones(K,reps);
freq_e_bs = -9999 * ones(reps,K);
rand('state', 123456789);
parfor i = 1:reps
    m = 0;
    match_bs = [];
    strg_M_bs = [];
    id2_bs = [];
    
    strg_e_bs = [];     % added for plus
    round_bs = [];     % added for plus
    
    s_bs = sort(randsample(s_val, no_session, 'true'));      % identifier of sessions randomly selected and sorted from smallest to largest
    for j = 1:no_session
        id_bs = id(session_foo == s_bs(j));
        match_j_bs = match(session_foo == s_bs(j));    % the matches to randomly draw from
        for k = 1:n_bs(j)  % resamples as many students as there are in the jth smallest session
            m = m+1;
            s_i_bs = randsample(id_bs, 1, 'true');
            match_k_bs = match_j_bs(id_bs == s_i_bs);
            match_foo = [];
            strg_foo = [];
            
            strg_e_foo = [];     % added for plus
            round_foo = [];     % added for plus
            
            for l = 1:no_match(j)
                match_l_bs = randsample(match_k_bs, 1, 'true');     % new
                match_foo = [match_foo; l*foo(match_k_bs == match_l_bs)];         % new
                strg_foo = [strg_foo; strg_M((id == s_i_bs) & (match == match_l_bs), 1:K)];

                strg_e_foo = [strg_e_foo; strg_e((id == s_i_bs) & (match == match_l_bs), 1:7)];     % added for plus
                round_foo = [round_foo; round((id == s_i_bs) & (match == match_l_bs), 1)];     % added for plus
            end    
            match_bs = [match_bs; match_foo];
            strg_M_bs = [strg_M_bs; strg_foo];
            id2_bs = [id2_bs; m*foo(1:size(match_foo))];  % this generates a different id for the same subject if he is randomly re-selected
            
            strg_e_bs = [strg_e_bs; strg_e_foo];     % added for plus
            round_bs = [round_bs; round_foo];     % added for plus
            
            if isempty(match_foo) == 1  % added because there are (rarely) cases where no match is randomly selected 
                m = m-1;
            end
            
        end
    end
    max_id_bs = max(id2_bs);
    min_id_bs = min(id2_bs);    
    max_match_bs = zeros(1,max_id_bs-min_id_bs+1);
    min_match_bs = zeros(1,max_id_bs-min_id_bs+1);
    for l = min_id_bs:max_id_bs
        max_match_bs(l) = max(match_bs(find(id2_bs==l)));
        min_match_bs(l) = min(match_bs(find(id2_bs==l)));
    end
    % optimization
    [x, ll, hess, exitflag] = opt_df_strat(match_bs, min_match_bs, max_match_bs, id2_bs, min_id_bs, max_id_bs, strg_M_bs, K, start);
    if x(1,1) > 1.5
        for s = 0.1:0.1:1.5
            [x_temp, ll_temp, hess_temp, exitflag_temp] = opt_df_strat(match_bs, min_match_bs, max_match_bs, id2_bs, min_id_bs, max_id_bs, strg_M_bs, K, [s; ones(K-1,1)/K]);
            if ll_temp < ll
               x = x_temp; ll = ll_temp; hess = hess_temp; exitflag = exitflag_temp;
            end
        end
    end
    if x(1,1)>1.5
        disp('strange');
        exit
    end
    if exitflag ~= 0
        if min(x) < 0, bar = x; bar(find(bar>0))=bar(find(bar>0))-(sum(bar(find(bar<0)))/length(find(bar>0)+1)); bar(find(bar<0))=0; x=bar; end
        % see if there's a possible improvement over current solution where some
        % probabilities are exactly 0
        for m = 3:20
            xx = x(2:K,1);
            baz = 0.1^m;
            if min(xx) < baz
                bar = xx; bar(find(bar>baz))=bar(find(bar>baz))+(sum(bar(find(bar<baz)))/length(find(bar>baz)+1)); bar(find(bar<baz))=0; xx = bar; start_foo=[x(1,1); xx];
                ll_foo = ll_df_strat(start_foo, match_bs, min_match_bs, max_match_bs, id2_bs, min_id_bs, max_id_bs, strg_M_bs, K);
                if ll_foo <= ll
                    x = start_foo; ll = ll_foo;
                end
            end
            xx = x(2:K,1);
            last_x = 1-sum(xx);
            if last_x < baz, bar = xx; bar(find(bar>baz))=bar(find(bar>baz))+(last_x/length(find(bar>baz))); xx = bar; start_foo=[x(1,1); xx];
                ll_foo = ll_df_strat(start_foo, match_bs, min_match_bs, max_match_bs, id2_bs, min_id_bs, max_id_bs, strg_M_bs, K);
                if ll_foo <= ll
                    x = start_foo; ll = ll_foo;
                end
            end
        end
    end
    if exitflag == 0   % This means there was a problem with the optimization so this iteration is dropped and the saved variables are unchanged
    else
        x_M(:,i) = x;
        % only keeping 1 elicited strategy per match
        strg_e_bs_1 = strg_e_bs(find(round_bs == 1), 1:K);     % added for plus
        % frequency of each strategy - row vector
        freq_e_bs(i,:) = mean(strg_e_bs_1);     % added for plus
    end;
    
%    i
end
x_M = x_M(:,find(x_M(1,:)~=-9999)); % this drops the columns with -9999
freq_e_bs = freq_e_bs(find(freq_e_bs(:,1)~=-9999),:); % this drops the rows with -9999


% variance-covariance
vc_bs = cov(x_M');

% Change log
% 06/22/16
%   - Line 60, changed "match_foo = [match_foo; m*foo(match_k_bs == match_l_bs)];"
%   for "match_foo = [match_foo; l*foo(match_k_bs == match_l_bs)];". It was
%   indexing the matches with the index for the subject id.
%   - added "max_match_bs = zeros(1,max_id_bs-min_id_bs+1);" and
%   "min_match_bs = zeros(1,max_id_bs-min_id_bs+1);"
%   in lines 81 and 82 in an attempt to switch to parfor instead of for (to
%   speed things up).
%   - freq_e_bs and x_M are now initialized as matrices of -9999; they used
%   to be empty. Both matrices used to be updated only if exitflag ~= 0
%   (otherwise they stayed the same). When they were updated, they were
%   updated this way freq_e_bs = [freq_e_bs; mean(strg_e_bs_1)] and x_M = [x_M, x];
%   Now each row or column is replaces when the exitflag is not 0 and after
%   the columns or rows with -9999 are dropped. This is all to allow the
%   use of parfor.
%   - Moved lines 113 and 114 outside of the loop (they used to be 110 and
%   111) where they should have been (as in bs_df_strat_plus_sim.m).



